#include <bits/stdc++.h>

using namespace std;

#define ll long long

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    ll t;
    cin >> n >> t;
    vector<ll> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    vector<ll> pref_sum(n + 1);
    for (int i = 1; i <= n; i++) {
        pref_sum[i] = pref_sum[i - 1] + arr[i - 1];
    }
    int l = 0;
    int r = n + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        bool prow = false;
        for (int i = m; i < n + 1; i++) {
            if (pref_sum[i] - pref_sum[i - m] > t) {
                prow = true;
                break;
            }
        }
        if (prow) {
            r = m;
        } else {
            l = m;
        }
    }
    if (r == n + 1) {
        cout << -1;
    } else {
        cout << r;
    }
    return 0;
}
