#include <bits/stdc++.h>

using namespace std;

#define ll long long

int func(unordered_multiset<char> &mt) {
    map<char, int> mp;
    for (char it: mt) {
        mp[it]++;
    }
    return mp.size();
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<char, char> > > arr(n, vector<pair<char, char> >(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            arr[i][j].second = s[j];
        }
    }
    for (int i = 0; i < n - 1; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            arr[i][j].first = s[j];
            arr[i + 1][j].first = s[j];
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--, y1--, x2--, y2--;
        deque<pair<pair<int, int>, unordered_multiset<char> > > deq;
        if (x1 < x2) {
            swap(x1, x2);
            swap(y1, y2);
        }
        unordered_multiset<char> u;
        deq.push_back({{x1, y1}, u});
        vector<vector<int> > visited(n, vector<int>(m, 1e7));
        visited[x1][y1] = 0;
        while (!deq.empty()) {
            pair<pair<int, int>, unordered_multiset<char> > d = deq.front();
            deq.pop_front();
            int id1 = d.first.first, id2 = d.first.second;
            if (id2 + 1 < m && visited[id1][id2 + 1] == 1e7) {
                if (d.second.find(arr[id1][id2].second) == d.second.end()) {
                    d.second.insert(arr[id1][id2].second);
                    deq.push_back({{id1, id2 + 1}, d.second});
                    visited[id1][id2 + 1] = func(d.second);
                } else {
                    d.second.insert(arr[id1][id2].second);
                    deq.push_front({{id1, id2 + 1}, d.second});
                    visited[id1][id2 + 1] = func(d.second);
                }
                d.second.erase(d.second.find(arr[id1][id2].second));
            }
            if (id1 + 1 < n && visited[id1 + 1][id2] == 1e7) {
                if (d.second.find(arr[id1][id2].first) == d.second.end()) {
                    d.second.insert(arr[id1][id2].first);
                    deq.push_back({{id1 + 1, id2}, d.second});
                    visited[id1 + 1][id2] = func(d.second);
                } else {
                    d.second.insert(arr[id1][id2].first);
                    deq.push_front({{id1 + 1, id2}, d.second});
                    visited[id1 + 1][id2] = func(d.second);
                }
                d.second.erase(d.second.find(arr[id1][id2].first));
            }
            if (id1 - 1 >= 0 && visited[id1 - 1][id2] == 1e7) {
                if (d.second.find(arr[id1 - 1][id2].first) == d.second.end()) {
                    d.second.insert(arr[id1 - 1][id2].first);
                    deq.push_back({{id1 - 1, id2}, d.second});
                    visited[id1 - 1][id2] = func(d.second);
                } else {
                    d.second.insert(arr[id1 - 1][id2].first);
                    deq.push_front({{id1 - 1, id2}, d.second});
                    visited[id1 - 1][id2] = func(d.second);
                }
                d.second.erase(d.second.find(arr[id1 - 1][id2].first));
            }
            if (id2 - 1 >= 0 && visited[id1][id2 - 1] == 1e7) {
                if (d.second.find(arr[id1][id2 - 1].second) == d.second.end()) {
                    d.second.insert(arr[id1][id2 - 1].second);
                    deq.push_back({{id1, id2 - 1}, d.second});
                    visited[id1][id2 - 1] = func(d.second);
                } else {
                    d.second.insert(arr[id1][id2 - 1].second);
                    deq.push_front({{id1, id2 - 1}, d.second});
                    visited[id1][id2 - 1] = func(d.second);
                }
                d.second.erase(d.second.find(arr[id1][id2 - 1].second));
            }
        }
        cout << visited[x2][y2] << '\n';
    }
    return 0;
}
