#include <bits/stdc++.h>

using namespace std;

#define ll long long

vector<vector<pair<char, char> > > arr;
bool dp[100][100][100][100];

string s = "BRGO";
int n, m;

bool prow(vector<char> &ar, int x1, int y1, int x2, int y2) {
    multiset<char> ms;
    for (char i: ar) {
        ms.insert(i);
    }
    deque<pair<int, int> > d;
    vector<vector<bool> > visited(n, vector<bool>(m));
    visited[x1][y1] = true;
    d.emplace_back(x1, y1);
    while (!d.empty()) {
        pair<int, int> it = d.front();
        d.pop_front();
        int x = it.first;
        int y = it.second;
        if (x - 1 >= 0 && ms.contains(arr[x - 1][y].first) && !visited[x - 1][y]) {
            visited[x - 1][y] = true;
            d.emplace_back(x - 1, y);
        }
        if (y - 1 >= 0 && ms.contains(arr[x][y - 1].second) && !visited[x][y - 1]) {
            visited[x][y - 1] = true;
            d.emplace_back(x, y - 1);
        }
        if (x + 1 < n && ms.contains(arr[x][y].first) && !visited[x + 1][y]) {
            visited[x + 1][y] = true;
            d.emplace_back(x + 1, y);
        }
        if (y + 1 < m && ms.contains(arr[x][y].second) && !visited[x][y + 1]) {
            visited[x][y + 1] = true;
            d.emplace_back(x, y + 1);
        }
    }
    return visited[x2][y2];
}

int answer = 4;

void solve(vector<char> &ans, int id, int x1, int y1, int x2, int y2) {
    if (id == s.size()) {
        if (ans.size() < answer && prow(ans, x1, y1, x2, y2)) {
            answer = min(answer, (int) ans.size());
        }
        return;
    }
    solve(ans, id + 1, x1, y1, x2, y2);
    ans.push_back(s[id]);
    solve(ans, id + 1, x1, y1, x2, y2);
    ans.pop_back();
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    arr.resize(n, vector<pair<char, char> >(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            arr[i][j].second = s[j];
        }
    }
    for (int i = 0; i < n - 1; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            arr[i][j].first = s[j];
            arr[i + 1][j].first = s[j];
        }
    }
    dp[0][0][0][0] = true;
    dp[43][45][3][1] = true;
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--, y1--, x2--, y2--;
        answer = 4;
        vector<char> ans;
        solve(ans, 0, x1, y1, x2, y2);
        cout << answer << '\n';
    }
    return 0;
}
