#include <bits/stdc++.h>

using namespace std;

#define ll long long

vector<vector<pair<char, char> > > arr;

string s = "BRGO";
int n, m;

char dp[100][100][100][100];

void prow(vector<char> &ar, int x1, int y1) {
    dp[x1][y1][x1][y1] = '0';
    unordered_set<char> ms;
    for (char i: ar) {
        ms.insert(i);
    }
    deque<pair<int, int> > d;
    vector<vector<bool> > visited(n, vector<bool>(m));
    visited[x1][y1] = true;
    d.emplace_back(x1, y1);
    while (!d.empty()) {
        pair<int, int> it = d.front();
        d.pop_front();
        int x = it.first;
        int y = it.second;
        if (x - 1 >= 0 && ms.find(arr[x - 1][y].first) != ms.end() && !visited[x - 1][y]) {
            visited[x - 1][y] = true;
            if (dp[x1][y1][x - 1][y] == '5') {
                dp[x1][y1][x - 1][y] = (char) ar.size();
            } else {
                dp[x1][y1][x - 1][y] = min(dp[x1][y1][x - 1][y], (char) ar.size());
            }
            if (dp[x - 1][y][x1][y1] == '5') {
                dp[x - 1][y][x1][y1] = (char) ar.size();
            } else {
                dp[x - 1][y][x1][y1] = min(dp[x - 1][y][x1][y1], (char) ar.size());
            }
            dp[x - 1][y][x - 1][y] = '0';
            d.emplace_back(x - 1, y);
        }
        if (y - 1 >= 0 && ms.find(arr[x][y - 1].second) != ms.end() && !visited[x][y - 1]) {
            if (dp[x1][y1][x][y - 1] == '5') {
                dp[x1][y1][x][y - 1] = (char) ar.size();
            } else {
                dp[x1][y1][x][y - 1] = min(dp[x1][y1][x][y - 1], (char) ar.size());
            }
            if (dp[x][y - 1][x1][y1] == '5') {
                dp[x][y - 1][x1][y1] = (char) ar.size();
            } else {
                dp[x][y - 1][x1][y1] = min(dp[x][y - 1][x1][y1], (char) ar.size());
            }
            dp[x][y - 1][x][y - 1] = '0';
            visited[x][y - 1] = true;
            d.emplace_back(x, y - 1);
        }
        if (x + 1 < n && ms.find(arr[x][y].first) != ms.end() && !visited[x + 1][y]) {
            char c = (char) ar.size();
            if (dp[x1][y1][x + 1][y] == '5') {
                dp[x1][y1][x + 1][y] = (char) ar.size();
            } else {
                dp[x1][y1][x + 1][y] = min(dp[x1][y1][x + 1][y], (char) ar.size());
            }
            if (dp[x + 1][y][x1][y1] == '5') {
                dp[x + 1][y][x1][y1] = (char) ar.size();
            } else {
                dp[x + 1][y][x1][y1] = min(dp[x + 1][y][x1][y1], (char) ar.size());
            }
            dp[x + 1][y][x + 1][y] = '0';
            visited[x + 1][y] = true;
            d.emplace_back(x + 1, y);
        }
        if (y + 1 < m && ms.find(arr[x][y].second) != ms.end() && !visited[x][y + 1]) {
            if (dp[x1][y1][x][y + 1] == '5') {
                dp[x1][y1][x][y + 1] = (char) ar.size();
            } else {
                dp[x1][y1][x][y + 1] = min(dp[x1][y1][x][y + 1], (char) ar.size());
            }
            if (dp[x][y + 1][x1][y1] == '5') {
                dp[x][y + 1][x1][y1] = (char) ar.size();
            } else {
                dp[x][y + 1][x1][y1] = min(dp[x][y + 1][x1][y1], (char) ar.size());
            }
            dp[x][y + 1][x][y + 1] = '0';
            visited[x][y + 1] = true;
            d.emplace_back(x, y + 1);
        }
    }
}


void solve(vector<char> &ans, int id, int x1, int y1) {
    if (id == s.size()) {
        prow(ans, x1, y1);
        return;
    }
    solve(ans, id + 1, x1, y1);
    ans.push_back(s[id]);
    solve(ans, id + 1, x1, y1);
    ans.pop_back();
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    arr.resize(n, vector<pair<char, char> >(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            arr[i][j].second = s[j];
        }
    }
    for (int i = 0; i < n - 1; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            arr[i][j].first = s[j];
            arr[i + 1][j].first = s[j];
        }
    }
    for (int i = 0; i < 100; i++) {
        for (int j = 0; j < 100; j++) {
            for (int k = 0; k < 100; k++) {
                for (int l = 0; l < 100; l++) {
                    dp[i][j][k][l] = '5';
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int k = 0; k < n; k++) {
                for (int l = 0; l < m; l++) {
                    if (dp[i][j][k][l] == '5') {
                        vector<char> ans;
                        solve(ans, 0, i, j);
                    }
                }
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--, y1--, x2--, y2--;
        cout << to_string(dp[x1][y1][x2][y2]) << '\n';
    }
    return 0;
}
